<template>
    <div class="clock-card is-card">
        <i class="description">Play Clock</i>
        <table>
            <tr>
                <td colspan="2">
                    <input
                        v-model.lazy="playClock.time"
                        class="hidden-input"
                        @focus="playClock.running && toggleClock()"
                    />
                </td>
                <td class="clicky" @click="toggleClock">
                    <i
                        :class="`fas fa-${
                            playClock.running ? 'pause' : 'play'
                        }`"
                    ></i>
                </td>
                <td class="clicky" @click="resetClock">
                    <i class="fas fa-redo"></i>
                </td>
            </tr>
            <tr>
                <td colspan="2" class="small">Clock Type:</td>
                <td
                    :class="[
                        playClock.type == 40 ? 'active' : '',
                        'clicky',
                        'small',
                    ]"
                    @click="setType(40)"
                >
                    40s
                </td>
                <td
                    :class="[
                        playClock.type == 25 ? 'active' : '',
                        'clicky',
                        'small',
                    ]"
                    @click="setType(25)"
                >
                    25s
                </td>
            </tr>
        </table>
    </div>
</template>

<script lang="ts">
import Vue from "vue";
import state from "~/state";

export default Vue.extend({
    data() {
        return {
            playTimes: [40, 25],
            countdown: -1,
        };
    },
    computed: {
        playClock() {
            return state.playClock;
        },
    },
    methods: {
        setType(type: PlayClockT) {
            this.playTimes[state.playClock.type === 40 ? 0 : 1] =
                state.playClock.time;
            state.playClock.type = type;
            if (state.playClock.running) {
                this.toggleClock();
            }
            state.playClock.time = this.playTimes[
                state.playClock.type === 40 ? 0 : 1
            ];
        },
        resetClock() {
            if (state.playClock.running) {
                this.toggleClock();
            }
            state.playClock.time = state.playClock.type;
        },
        toggleClock() {
            if (state.playClock.running) {
                clearInterval(this.countdown);
            } else {
                state.playClock.time--;
                this.countdown = (setInterval(() => {
                    if (state.playClock.time === 0) {
                        clearInterval(this.countdown);
                    } else {
                        state.playClock.time--;
                    }
                }, 1000) as unknown) as number;
            }

            state.playClock.running = !state.playClock.running;
        },
    },
});
</script>
